%define anolis_release 4
%define version_num 0.1.9
%define github_version %{version_num}~beta

Name:		dml
Version:	%{github_version}
Release:	%{anolis_release}%{?dist}
Summary:	Intel® Data Mover Library (Intel® DML)
License:	MIT
URL:		https://github.com/intel/DML
Source0:	https://github.com/intel/DML/archive/refs/tags/v%{version_num}-beta.tar.gz

Patch1001:	1001-bugfix-build-error-in-gcc-12.patch
Patch1002: 	1002-remove-googletest-in-source.patch
Patch1003:	1003-remove-werror-to-fix-build-error.patch

BuildRequires:	accel-config > 3.2 kernel-devel > 5.10
BuildRequires:	gcc-c++ cmake gcc
BuildRequires:  libuuid-devel
BuildRequires:  doxygen
BuildRequires:  python3-devel
BuildRequires:  gmock-devel gtest-devel

ExclusiveArch:  x86_64

%package devel
Summary:	header files for %{name}.
Requires:	%{name} = %{version}-%{release}

%description devel
Header file for %{name}.

%package tests
Summary:	Tests files for %{name}
Requires:       %{name} = %{version}-%{release}

%description    tests
The %{name}-tests package contains tests files for %{name}.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%description
Intel® Data Mover Library (Intel® DML) is an open-source library to provide 
high-performance data manipulation on Intel CPUs. Intel® DML is intended for 
streaming data movement and transformation operations optimization that is 
applicable for effective storage, networking, persistent memory, and various 
data processing applications.

%prep
%autosetup -n DML-%{version_num}-beta -p1

%build
%cmake
%cmake_build

%install
%cmake_install

%generate_compatibility_deps

find $RPM_BUILD_ROOT -name '*.la' -exec rm -f {} ';'
find $RPM_BUILD_ROOT -name '*.a' -exec rm -f {} ';'

pushd %{buildroot}%{_bindir}
mv tests %{name}_tests
mv tests_mt %{name}_tests_mt
mv job_api_samples %{name}_job_api_samples
popd

%files
%license LICENSE
%doc CODEOWNERS
%dir %{abidir}

%files devel
%{_includedir}/dml/*
%{_libdir}/cmake/Dml/*.cmake

%files tests
%{_bindir}/%{name}_test_*
%{_bindir}/%{name}_tests
%{_bindir}/%{name}_tests_mt
%{_bindir}/%{name}_job_api_samples
%{abidir}/*-option.list

%files doc
%doc README.md SECURITY.md CONTRIBUTING.md 

%changelog
* Mon Dec 09 2024 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.1.9~beta-4
- Rebuild for remove inappropriate build dependencies.

* Tue Mar 7 2023 Funda Wang <fundawang@yeah.net> - 0.19~beta-3
- Rebuild for new gtest

* Mon Oct 17 2022 happy_orange <songnannan@linux.alibaba.com> - 0.1.9~beta-2
- add tests package.

* Wed Aug 03 2022 happy_orange <songnannan@linux.alibaba.com> - 0.1.9~beta-1
- Init package from upstream
